---
description: Main menu when using plain markdown. Excluded when generating the website
---
# <img src="images/logo.png" height="64px"/> Telepresence Documentation
raw markdown version, more bells and whistles at [telepresence.io](https://telepresence.io)

- [Quick start](quick-start.md)
- Install Telepresence
  - [Install Client](install/client.md)
  - [Upgrade Client](install/upgrade.md)
  - [Install Traffic Manager](install/manager.md)
  - [Cloud Provider Prerequisites](install/cloud.md)
- Core concepts
  - [The developer experience and the inner dev loop](concepts/devloop.md)
  - [Making the remote local: Faster feedback, collaboration and debugging](concepts/faster.md)
  - [Using Telepresence with Docker](concepts/docker.md)
  - [Intercepts](concepts/intercepts.md)
- How do I...
  - [Intercept a service in your own environment](howtos/intercepts.md)
  - [Proxy outbound traffic to my cluster](howtos/outbound.md)
  - [Work with large clusters](howtos/large-clusters.md)
  - [Host a cluster in a local VM](howtos/cluster-in-vm.md)
- Technical reference
  - [Architecture](reference/architecture.md)
  - [Client reference](reference/client.md)
  - [Laptop-side configuration](reference/config.md)
  - [Cluster-side configuration](reference/cluster-config.md)
  - [Using Docker for intercepts](reference/docker-run.md)
  - [Running Telepresence in a Docker container](reference/inside-container.md)
  - [Environment variables](reference/environment.md)
  - Intercepts
    - [Configure intercept using CLI](reference/intercepts/cli.md)
    - [Traffic Agent Sidecar](reference/intercepts/sidecar.md)
  - [Volume mounts](reference/volume.md)
  - [DNS resolution](reference/dns.md)
  - [RBAC](reference/rbac.md)
  - [Telepresence and VPNs](reference/vpn.md)
  - [Networking through Virtual Network Interface](reference/tun-device.md)
  - [Connection Routing](reference/routing.md)
  - [Monitoring](reference/monitoring.md)
- [FAQs](faqs.md)
- [Troubleshooting](troubleshooting.md)
- [Community](community.md)
- [Release Notes](release-notes.md)
- [Licenses](licenses.md)
